Index: cpukit/libmisc/monitor/mon-symbols.c
===================================================================
--- cpukit/libmisc/monitor/mon-symbols.c	(revision 637df35f96d8023056369fcf2c9943419f1a1b74)
+++ cpukit/libmisc/monitor/mon-symbols.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -1,5 +1,6 @@
 /*
- *      @(#)symbols.c	1.3 - 95/04/24
+ *      @(#)symbols.c	1.10 - 95/08/02
  *      
+ *  $Id$
  */
 
@@ -22,32 +23,7 @@
 #include <string.h>
 
+#include "monitor.h"
 #include "symbols.h"
 
-extern rtems_symbol_table_t *rtems_monitor_symbols;
-
-#ifdef RTEMS_DEBUG
-#define CHK_ADR_PTR(p)  \
-do { \
-    if (((p) < rtems_monitor_symbols->addresses) || \
-        ((p) >= (rtems_monitor_symbols->addresses + rtems_monitor_symbols->next))) \
-    { \
-        printf("bad address pointer %p\n", (p)); \
-        rtems_fatal_error_occurred(RTEMS_INVALID_ADDRESS); \
-    } \
-} while (0)
-
-#define CHK_NAME_PTR(p) \
-do { \
-    if (((p) < rtems_monitor_symbols->symbols) || \
-        ((p) >= (rtems_monitor_symbols->symbols + rtems_monitor_symbols->next))) \
-    { \
-        printf("bad symbol pointer %p\n", (p)); \
-        rtems_fatal_error_occurred(RTEMS_INVALID_ADDRESS); \
-    } \
-} while (0)
-#else
-#define CHK_ADR_PTR(p)
-#define CHK_NAME_PTR(p)
-#endif
 
 rtems_symbol_table_t *
@@ -179,7 +155,4 @@
     s2 = (rtems_symbol_t *) e2;
 
-    CHK_ADR_PTR(s1);
-    CHK_ADR_PTR(s2);
-
     if (s1->value < s2->value)
         return -1;
@@ -200,7 +173,4 @@
     s1 = (rtems_symbol_t *) e1;
     s2 = (rtems_symbol_t *) e2;
-
-    CHK_NAME_PTR(s1);
-    CHK_NAME_PTR(s2);
 
     return strcasecmp(s1->name, s2->name);
@@ -252,4 +222,7 @@
     rtems_unsigned32 best_distance = ~0;
     rtems_unsigned32 elements;
+
+    if (table == 0)
+        table = rtems_monitor_symbols;
 
     if ((table == 0) || (table->size == 0))
@@ -301,11 +274,12 @@
     rtems_symbol_t  key;
 
+    if (table == 0)
+        table = rtems_monitor_symbols;
+
     if ((table == 0) || (name == 0))
         goto done;
 
     if (table->sorted == 0)
-    {
         rtems_symbol_sort(table);
-    }
 
     /*
@@ -326,2 +300,191 @@
 }
 
+void *
+rtems_monitor_symbol_next(
+    void                   *object_info,
+    rtems_monitor_symbol_t *canonical,
+    rtems_id               *next_id
+)
+{
+    rtems_symbol_table_t *table;
+    int n = rtems_get_index(*next_id);
+
+    table = *(rtems_symbol_table_t **) object_info;
+    if (table == 0)
+        goto failed;
+
+    if (n >= table->next)
+        goto failed;
+
+    /* NOTE: symbols do not have id and name fields */
+      
+    if (table->sorted == 0)
+        rtems_symbol_sort(table);
+
+    _Thread_Disable_dispatch();
+
+    *next_id += 1;
+    return (void *) (table->symbols + n);
+
+failed:
+    *next_id = RTEMS_OBJECT_ID_FINAL;
+    return 0;
+}
+
+void
+rtems_monitor_symbol_canonical(
+    rtems_monitor_symbol_t *canonical_symbol,
+    rtems_symbol_t *sp
+)
+{
+    canonical_symbol->value = sp->value;
+    canonical_symbol->offset = 0;
+    strncpy(canonical_symbol->name, sp->name, sizeof(canonical_symbol->name));
+}
+
+
+void
+rtems_monitor_symbol_canonical_by_name(
+    rtems_monitor_symbol_t *canonical_symbol,
+    char                   *name
+)
+{
+    rtems_symbol_t *sp;
+
+    sp = rtems_symbol_name_lookup(0, name);
+
+    canonical_symbol->value = sp ? sp->value : 0;
+
+    strncpy(canonical_symbol->name, name, sizeof(canonical_symbol->name));
+    canonical_symbol->offset = 0;
+}
+
+void
+rtems_monitor_symbol_canonical_by_value(
+    rtems_monitor_symbol_t *canonical_symbol,
+    void                   *value_void_p
+)
+{
+    unsigned32 value = (unsigned32) value_void_p;
+    rtems_symbol_t *sp;
+
+    sp = rtems_symbol_value_lookup(0, value);
+    if (sp)
+    {
+        canonical_symbol->value = sp->value;
+        canonical_symbol->offset = value - sp->value;
+        strncpy(canonical_symbol->name, sp->name, sizeof(canonical_symbol->name));
+    }
+    else
+    {
+        canonical_symbol->value = value;
+        canonical_symbol->offset = 0;
+        canonical_symbol->name[0] = '\0';
+    }
+}
+
+
+unsigned32
+rtems_monitor_symbol_dump(
+    rtems_monitor_symbol_t *canonical_symbol,
+    boolean                 verbose
+)
+{
+    unsigned32 length = 0;
+
+    /*
+     * print the name if it exists AND if value is non-zero
+     * Ie: don't print some garbage symbol for address 0
+     */
+
+    if (canonical_symbol->name[0] && (canonical_symbol->value != 0))
+    {
+        if (canonical_symbol->offset == 0)
+            length += printf("%.*s",
+                             sizeof(canonical_symbol->name),
+                             canonical_symbol->name);
+        else
+            length += printf("<%.*s+0x%x>",
+                             sizeof(canonical_symbol->name),
+                             canonical_symbol->name,
+                             canonical_symbol->offset);
+        if (verbose)
+            length += printf(" [0x%x]", canonical_symbol->value);
+    }
+    else
+        length += printf("[0x%x]", canonical_symbol->value);
+
+    return length;
+}
+
+
+void
+rtems_monitor_symbol_dump_all(
+    rtems_symbol_table_t *table,
+    boolean               verbose
+)
+{
+    int s;
+    rtems_symbol_t *sp;
+
+    if (table == 0)
+    {
+        table = rtems_monitor_symbols;
+        if (table == 0)
+            return;
+    }
+
+    if (table->sorted == 0)
+        rtems_symbol_sort(table);
+
+    for (s = 0, sp = table->symbols; s < table->next; s++, sp++)
+    {
+        rtems_monitor_symbol_t canonical_symbol;
+
+        rtems_monitor_symbol_canonical(&canonical_symbol, sp);
+        rtems_monitor_symbol_dump(&canonical_symbol, TRUE);
+        printf("\n");
+    }
+}
+
+
+/*
+ * 'symbol' command
+ */
+
+void
+rtems_monitor_symbol_cmd(
+    int        argc,
+    char     **argv,
+    unsigned32 command_arg,
+    boolean    verbose
+)
+{
+    int arg;
+    rtems_symbol_table_t *table;
+
+    table = *(rtems_symbol_table_t **) command_arg;
+    if (table == 0)
+    {
+        table = rtems_monitor_symbols;
+        if (table == 0)
+            return;
+    }
+
+    /*
+     * Use object command to dump out whole symbol table
+     */
+    if (argc == 1)
+        rtems_monitor_symbol_dump_all(table, verbose);
+    else
+    {
+        rtems_monitor_symbol_t canonical_symbol;
+
+        for (arg=1; argv[arg]; arg++)
+        {
+            rtems_monitor_symbol_canonical_by_name(&canonical_symbol, argv[arg]);
+            rtems_monitor_symbol_dump(&canonical_symbol, verbose);
+            printf("\n");
+        }
+    }
+}
Index: cpukit/libmisc/monitor/mon-task.c
===================================================================
--- cpukit/libmisc/monitor/mon-task.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
+++ cpukit/libmisc/monitor/mon-task.c	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -0,0 +1,85 @@
+/*
+ *	@(#)task.c	1.9 - 95/08/01
+ *	
+ *
+ * RTEMS Monitor task support
+ *
+ *  $Id$
+ */
+
+#include <rtems.h>
+#include "monitor.h"
+
+#include <stdio.h>
+
+void
+rtems_monitor_task_canonical(
+    rtems_monitor_task_t  *canonical_task,
+    void                  *thread_void
+)
+{
+    Thread_Control       *rtems_thread = (Thread_Control *) thread_void;
+    
+    canonical_task->entry = rtems_thread->Start.entry_point;
+    canonical_task->argument = rtems_thread->Start.initial_argument;
+    canonical_task->stack = rtems_thread->Start.Initial_stack.area;
+    canonical_task->stack_size = rtems_thread->Start.Initial_stack.size;
+    canonical_task->priority = rtems_thread->current_priority;
+    canonical_task->state = rtems_thread->current_state;
+    canonical_task->wait_id = rtems_thread->Wait.id;
+    canonical_task->events = rtems_thread->pending_events;
+    canonical_task->modes = rtems_thread->current_modes;
+    canonical_task->attributes = rtems_thread->attribute_set;
+    (void) memcpy(canonical_task->notepad, rtems_thread->Notepads, sizeof(canonical_task->notepad));
+    (void) memcpy(&canonical_task->wait_args, &rtems_thread->Wait.Extra, sizeof(canonical_task->wait_args));
+}
+
+
+void
+rtems_monitor_task_dump_header(
+    boolean verbose
+)
+{
+    printf("\
+  ID       NAME   PRIO   STAT   MODES  EVENTS   WAITID  WAITARG  NOTES\n");
+/*23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
+0         1         2         3         4         5         6         7       */
+           
+    rtems_monitor_separator();
+}
+
+/*
+ */
+
+void
+rtems_monitor_task_dump(
+    rtems_monitor_task_t *monitor_task,
+    boolean  verbose
+)
+{
+    int length = 0;
+
+    length += rtems_monitor_dump_id(monitor_task->id);
+    length += rtems_monitor_pad(11, length);
+    length += rtems_monitor_dump_name(monitor_task->name);
+    length += rtems_monitor_pad(18, length);
+    length += rtems_monitor_dump_priority(monitor_task->priority);
+    length += rtems_monitor_pad(24, length);
+    length += rtems_monitor_dump_state(monitor_task->state);
+    length += rtems_monitor_pad(31, length);
+    length += rtems_monitor_dump_modes(monitor_task->modes);
+    length += rtems_monitor_pad(39, length);
+    length += rtems_monitor_dump_events(monitor_task->events);
+    if (monitor_task->wait_id)
+    {
+        length += rtems_monitor_pad(47, length);
+        length += rtems_monitor_dump_id(monitor_task->wait_id);
+        length += rtems_monitor_pad(57, length);
+        length += rtems_monitor_dump_hex(monitor_task->wait_args);
+    }
+
+    length += rtems_monitor_pad(65, length);
+    length += rtems_monitor_dump_notepad(monitor_task->notepad);
+    printf("\n");
+}
+
Index: cpukit/libmisc/monitor/monitor.h
===================================================================
--- cpukit/libmisc/monitor/monitor.h	(revision 637df35f96d8023056369fcf2c9943419f1a1b74)
+++ cpukit/libmisc/monitor/monitor.h	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -1,5 +1,6 @@
 /*
- *      @(#)monitor.h	1.2 - 95/04/24
+ *      @(#)monitor.h	1.14 - 95/08/02
  *      
+ *  $Id$
  */
 
@@ -10,12 +11,12 @@
  *    The RTEMS monitor task include file.
  *
- *
- *
  *  TODO:
- *
  */
 
 #ifndef __MONITOR_H
 #define __MONITOR_H
+
+#include "symbols.h"
+#include <rtems/error.h>		/* rtems_error() */
 
 #ifdef __cplusplus
@@ -23,12 +24,414 @@
 #endif
 
-void    rtems_monitor_init(rtems_boolean monitor_suspend);
+/*
+ * XXX this should be in rtems proper when type becomes part of id
+ */
+
+typedef enum {
+    RTEMS_OBJECT_INVALID   =  0,
+    RTEMS_OBJECT_TASK      =  1,
+    RTEMS_OBJECT_EXTENSION =  2,
+    RTEMS_OBJECT_QUEUE     =  3,
+    RTEMS_OBJECT_SEMAPHORE =  4,
+    RTEMS_OBJECT_DRIVER    =  5,
+    RTEMS_OBJECT_DNAME     =  6,
+    RTEMS_OBJECT_CONFIG    =  7,
+    RTEMS_OBJECT_INIT_TASK =  8,
+    RTEMS_OBJECT_MPCI      =  9,
+    RTEMS_OBJECT_PARTITION = 10,
+    RTEMS_OBJECT_REGION    = 11,
+    RTEMS_OBJECT_PORT      = 12,
+    RTEMS_OBJECT_SYMBOL    = 13,
+} rtems_object_type_t;
+
+/*
+ * rtems_monitor_init() flags
+ */
+
+#define RTEMS_MONITOR_SUSPEND	0x0001		/* suspend monitor on startup */
+#define RTEMS_MONITOR_GLOBAL    0x0002          /* monitor should be global */
+
+
+/*
+ * Public interfaces for RTEMS data structures monitor is aware of.
+ * These are only used by the monitor.
+ *
+ * NOTE:
+ *  All the canonical objects that correspond to RTEMS managed "objects"
+ *  must have an identical first portion with 'id' and 'name' fields.
+ *
+ *  Others do not have that restriction, even tho we would like them to.
+ *  This is because some of the canonical structures are almost too big
+ *  for shared memory driver (eg: mpci) and we are nickel and diming it.
+ */
+
+/*
+ * Type of a pointer that may be a symbol
+ */
+    
+#define MONITOR_SYMBOL_LEN 20
+typedef struct {
+    char       name[MONITOR_SYMBOL_LEN];
+    unsigned32 value;
+    unsigned32 offset;
+} rtems_monitor_symbol_t;    
+
+typedef struct {
+    rtems_id            id;
+    rtems_name          name;
+  /* end of common portion */
+} rtems_monitor_generic_t;        
+
+/*
+ * Task
+ */
+typedef struct {
+    rtems_id            id;
+    rtems_name          name;
+  /* end of common portion */
+    Thread_Entry        entry;
+    unsigned32          argument;
+    void               *stack;
+    unsigned32          stack_size;
+    rtems_task_priority priority;
+    States_Control      state;
+    rtems_event_set     events;
+    rtems_mode          modes;
+    rtems_attribute     attributes;
+    unsigned32          notepad[RTEMS_NUMBER_NOTEPADS];
+    rtems_id            wait_id;
+    unsigned32          wait_args;
+} rtems_monitor_task_t;
+
+/*
+ * Init task
+ */
+
+typedef struct {
+    rtems_id            id;		/* not really an id */
+    rtems_name          name;
+  /* end of common portion */
+    rtems_monitor_symbol_t entry;
+    unsigned32             argument;
+    unsigned32             stack_size;
+    rtems_task_priority    priority;
+    rtems_mode             modes;
+    rtems_attribute        attributes;
+} rtems_monitor_init_task_t;
+
+
+/*
+ * Message queue
+ */
+typedef struct {
+    rtems_id            id;
+    rtems_name          name;
+  /* end of common portion */
+    rtems_attribute     attributes;
+    unsigned32          number_of_pending_messages;
+    unsigned32          maximum_pending_messages;
+    unsigned32          maximum_message_size;
+} rtems_monitor_queue_t;
+
+/*
+ * Extension
+ */
+typedef struct {
+    rtems_id                 id;
+    rtems_name               name;
+  /* end of common portion */
+    rtems_monitor_symbol_t  create;
+    rtems_monitor_symbol_t  start;
+    rtems_monitor_symbol_t  restart;
+    rtems_monitor_symbol_t  delete;
+    rtems_monitor_symbol_t  tswitch;
+    rtems_monitor_symbol_t  begin;
+    rtems_monitor_symbol_t  exitted;
+    rtems_monitor_symbol_t  fatal;
+} rtems_monitor_extension_t;
+
+/*
+ * Device driver
+ */
+
+typedef struct {
+    rtems_id            id;		   /* not really an id (should be tho) */
+    rtems_name          name;              /* ditto */
+  /* end of common portion */
+    rtems_monitor_symbol_t initialization; /* initialization procedure */
+    rtems_monitor_symbol_t open;           /* open request procedure */
+    rtems_monitor_symbol_t close;          /* close request procedure */
+    rtems_monitor_symbol_t read;           /* read request procedure */
+    rtems_monitor_symbol_t write;          /* write request procedure */
+    rtems_monitor_symbol_t control;        /* special functions procedure */
+} rtems_monitor_driver_t;
+
+typedef struct {
+    rtems_id            id;		    /* not used for drivers (yet) */
+    rtems_name          name;               /* not used for drivers (yet) */
+  /* end of common portion */
+    unsigned32          major;
+    unsigned32          minor;
+    char                name_string[64];
+} rtems_monitor_dname_t;
+
+/*
+ * System config
+ */
+
+typedef struct {
+    void               *work_space_start;
+    unsigned32          work_space_size;
+    unsigned32          maximum_tasks;
+    unsigned32          maximum_timers;
+    unsigned32          maximum_semaphores;
+    unsigned32          maximum_message_queues;
+    unsigned32          maximum_partitions;
+    unsigned32          maximum_regions;
+    unsigned32          maximum_ports;
+    unsigned32          maximum_periods;
+    unsigned32          maximum_extensions;
+    unsigned32          microseconds_per_tick;
+    unsigned32          ticks_per_timeslice;
+    unsigned32          number_of_initialization_tasks;
+} rtems_monitor_config_t;
+
+/*
+ * MPCI config
+ */
+
+typedef struct {
+    unsigned32  node;                   /* local node number */
+    unsigned32  maximum_nodes;          /* maximum # nodes in system */
+    unsigned32  maximum_global_objects; /* maximum # global objects */
+    unsigned32  maximum_proxies;        /* maximum # proxies */
+
+    unsigned32               default_timeout;        /* in ticks */
+    unsigned32               maximum_packet_size;
+    rtems_monitor_symbol_t   initialization;
+    rtems_monitor_symbol_t   get_packet;
+    rtems_monitor_symbol_t   return_packet;
+    rtems_monitor_symbol_t   send_packet;
+    rtems_monitor_symbol_t   receive_packet;
+} rtems_monitor_mpci_t;
+
+/*
+ * The generic canonical information union
+ */
+
+typedef union {
+    rtems_monitor_generic_t    generic;
+    rtems_monitor_task_t       task;
+    rtems_monitor_queue_t      queue;
+    rtems_monitor_extension_t  extension;
+    rtems_monitor_driver_t     driver;
+    rtems_monitor_dname_t      dname;
+    rtems_monitor_config_t     config;
+    rtems_monitor_mpci_t       mpci;
+    rtems_monitor_init_task_t  itask;
+} rtems_monitor_union_t;
+
+/*
+ * Support for talking to other monitors
+ */
+
+/*
+ * Names of other monitors
+ */
+
+#define RTEMS_MONITOR_NAME        (rtems_build_name('R', 'M', 'O', 'N'))
+#define RTEMS_MONITOR_SERVER_NAME (rtems_build_name('R', 'M', 'S', 'V'))
+#define RTEMS_MONITOR_QUEUE_NAME  (rtems_build_name('R', 'M', 'S', 'Q'))
+#define RTEMS_MONITOR_RESPONSE_QUEUE_NAME (rtems_build_name('R', 'M', 'R', 'Q'))
+
+#define RTEMS_MONITOR_SERVER_RESPONSE    0x0001
+#define RTEMS_MONITOR_SERVER_CANONICAL   0x0002
+
+typedef struct
+{
+    unsigned32  command;
+    rtems_id    return_id;
+    unsigned32  argument0;
+    unsigned32  argument1;
+    unsigned32  argument2;
+    unsigned32  argument3;
+    unsigned32  argument4;
+    unsigned32  argument5;
+} rtems_monitor_server_request_t;
+
+typedef struct
+{
+    unsigned32  command;
+    unsigned32  result0;
+    unsigned32  result1;
+    rtems_monitor_union_t payload;
+} rtems_monitor_server_response_t;
+
+extern rtems_id  rtems_monitor_task_id;
+
+extern unsigned32 rtems_monitor_node;	       /* our node number */
+extern unsigned32 rtems_monitor_default_node;  /* current default for commands */
+
+/*
+ * Monitor command function and table entry
+ */
+
+typedef struct rtems_monitor_command_entry_s rtems_monitor_command_entry_t;
+
+typedef void ( *rtems_monitor_command_function_t )(
+                 int         argc,
+                 char      **argv,
+                 unsigned32  command_arg,
+                 boolean     verbose
+             );
+
+struct rtems_monitor_command_entry_s {
+    char        *command;      /* command name */
+    char        *usage;        /* usage string for the command */
+    unsigned32   arguments_required;    /* # of required args */
+    rtems_monitor_command_function_t command_function;
+
+                               /* Some argument for the command */
+    unsigned32          command_arg;
+};
+
+typedef void *(*rtems_monitor_object_next_fn)(void *, void *, rtems_id *);
+typedef void (*rtems_monitor_object_canonical_fn)(void *, void *);
+typedef void (*rtems_monitor_object_dump_header_fn)(boolean);
+typedef void (*rtems_monitor_object_dump_fn)(void *, boolean);
+
+typedef struct {
+    rtems_object_type_t                 type;
+    void                               *object_information;
+    int                                 size;	/* of canonical object */
+    rtems_monitor_object_next_fn        next;
+    rtems_monitor_object_canonical_fn   canonical;
+    rtems_monitor_object_dump_header_fn dump_header;
+    rtems_monitor_object_dump_fn        dump;
+} rtems_monitor_object_info_t;
+
+
+/* monitor.c */
+void    rtems_monitor_kill(void);
+void    rtems_monitor_init(rtems_boolean);
 void    rtems_monitor_wakeup(void);
-void    rtems_monitor_task(rtems_task_argument monitor_suspend);
+void    rtems_monitor_pause_cmd(int, char **, unsigned32, boolean);
+void    rtems_monitor_fatal_cmd(int, char **, unsigned32, boolean);
+void    rtems_monitor_continue_cmd(int, char **, unsigned32, boolean);
+void    rtems_monitor_node_cmd(int, char **, unsigned32, boolean);
 void    rtems_monitor_symbols_loadup(void);
-
-extern rtems_unsigned32        rtems_monitor_task_id;
+void    rtems_monitor_task(rtems_task_argument);
+
+/* server.c */
+void    rtems_monitor_server_kill(void);
+rtems_status_code rtems_monitor_server_request(unsigned32, rtems_monitor_server_request_t *, rtems_monitor_server_response_t *);
+void    rtems_monitor_server_task(rtems_task_argument);
+void    rtems_monitor_server_init(unsigned32);
+  
+/* command.c */
+int     rtems_monitor_make_argv(char *, int *, char **);
+int     rtems_monitor_command_read(char *, int *, char **);
+rtems_monitor_command_entry_t *rtems_monitor_command_lookup(
+    rtems_monitor_command_entry_t * table, int argc, char **argv);
+void    rtems_monitor_command_usage(rtems_monitor_command_entry_t *, char *);
+void    rtems_monitor_help_cmd(int, char **, unsigned32, boolean);
+
+/* prmisc.c */
+void       rtems_monitor_separator(void);
+unsigned32 rtems_monitor_pad(unsigned32 dest_col, unsigned32 curr_col);
+unsigned32 rtems_monitor_dump_char(unsigned8 ch);
+unsigned32 rtems_monitor_dump_decimal(unsigned32 num);
+unsigned32 rtems_monitor_dump_hex(unsigned32 num);
+unsigned32 rtems_monitor_dump_id(rtems_id id);
+unsigned32 rtems_monitor_dump_name(rtems_name name);
+unsigned32 rtems_monitor_dump_priority(rtems_task_priority priority);
+unsigned32 rtems_monitor_dump_state(States_Control state);
+unsigned32 rtems_monitor_dump_modes(rtems_mode modes);
+unsigned32 rtems_monitor_dump_attributes(rtems_attribute attributes);
+unsigned32 rtems_monitor_dump_events(rtems_event_set events);
+unsigned32 rtems_monitor_dump_notepad(unsigned32 *notepad);
+
+/* object.c */
+rtems_id   rtems_monitor_id_fixup(rtems_id, unsigned32, rtems_object_type_t);
+rtems_id   rtems_monitor_object_canonical_get(rtems_object_type_t, rtems_id, void *, unsigned32 *size_p);
+rtems_id   rtems_monitor_object_canonical_next(rtems_monitor_object_info_t *, rtems_id, void *);
+void      *rtems_monitor_object_next(void *, void *, rtems_id, rtems_id *);
+rtems_id   rtems_monitor_object_canonical(rtems_id, void *);
+void       rtems_monitor_object_cmd(int, char **, unsigned32, boolean);
+
+/* manager.c */
+void      *rtems_monitor_manager_next(void *, void *, rtems_id *);
+
+/* config.c */
+void       rtems_monitor_config_canonical(rtems_monitor_config_t *, void *);
+void      *rtems_monitor_config_next(void *, rtems_monitor_config_t *, rtems_id *);
+void       rtems_monitor_config_dump_header(boolean);
+void       rtems_monitor_config_dump(rtems_monitor_config_t *, boolean verbose);
+
+/* mpci.c */
+void       rtems_monitor_mpci_canonical(rtems_monitor_mpci_t *, void *);
+void      *rtems_monitor_mpci_next(void *, rtems_monitor_mpci_t *, rtems_id *);
+void       rtems_monitor_mpci_dump_header(boolean);
+void       rtems_monitor_mpci_dump(rtems_monitor_mpci_t *, boolean verbose);
+
+/* itask.c */
+void       rtems_monitor_init_task_canonical(rtems_monitor_init_task_t *, void *);
+void      *rtems_monitor_init_task_next(void *, rtems_monitor_init_task_t *, rtems_id *);
+void       rtems_monitor_init_task_dump_header(boolean);
+void       rtems_monitor_init_task_dump(rtems_monitor_init_task_t *, boolean verbose);
+
+/* extension.c */
+void       rtems_monitor_extension_canonical(rtems_monitor_extension_t *, void *);
+void       rtems_monitor_extension_dump_header(boolean verbose);
+void       rtems_monitor_extension_dump(rtems_monitor_extension_t *, boolean);
+
+/* task.c */
+void    rtems_monitor_task_canonical(rtems_monitor_task_t *, void *);
+void    rtems_monitor_task_dump_header(boolean verbose);
+void    rtems_monitor_task_dump(rtems_monitor_task_t *, boolean);
+
+/* queue.c */
+void    rtems_monitor_queue_canonical(rtems_monitor_queue_t *, void *);
+void    rtems_monitor_queue_dump_header(boolean verbose);
+void    rtems_monitor_queue_dump(rtems_monitor_queue_t *, boolean);
+
+/* driver.c */
+void    *rtems_monitor_driver_next(void *, rtems_monitor_driver_t *, rtems_id *);
+void     rtems_monitor_driver_canonical(rtems_monitor_driver_t *, void *);
+void     rtems_monitor_driver_dump_header(boolean);
+void     rtems_monitor_driver_dump(rtems_monitor_driver_t *, boolean);
+
+/* dname.c */
+void    *rtems_monitor_dname_next(void *, rtems_monitor_dname_t *, rtems_id *);
+void     rtems_monitor_dname_canonical(rtems_monitor_dname_t *, void *);
+void     rtems_monitor_dname_dump_header(boolean);
+void     rtems_monitor_dname_dump(rtems_monitor_dname_t *, boolean);
+
+/* symbols.c */
+rtems_symbol_table_t *rtems_symbol_table_create();
+void                  rtems_symbol_table_destroy(rtems_symbol_table_t *table);
+
+rtems_symbol_t *rtems_symbol_create(rtems_symbol_table_t *, char *, unsigned32);
+rtems_symbol_t *rtems_symbol_value_lookup(rtems_symbol_table_t *, unsigned32);
+rtems_symbol_t *rtems_symbol_name_lookup(rtems_symbol_table_t *, char *);
+void   *rtems_monitor_symbol_next(void *object_info, rtems_monitor_symbol_t *, rtems_id *);
+void    rtems_monitor_symbol_canonical(rtems_monitor_symbol_t *, rtems_symbol_t *);
+void    rtems_monitor_symbol_canonical_by_name(rtems_monitor_symbol_t *, char *);
+void    rtems_monitor_symbol_canonical_by_value(rtems_monitor_symbol_t *, void *);
+unsigned32 rtems_monitor_symbol_dump(rtems_monitor_symbol_t *, boolean);
+void    rtems_monitor_symbol_cmd(int, char **, unsigned32, boolean);
+
 
 extern rtems_symbol_table_t *rtems_monitor_symbols;
+
+#ifndef MONITOR_PROMPT
+#define MONITOR_PROMPT "rtems"		/* will have '> ' appended */
+#endif
+
+#define MONITOR_WAKEUP_EVENT   RTEMS_EVENT_0
+
+
+#define STREQ(a,b)	(strcmp(a,b) == 0)
+#define STRNEQ(a,b,n)	(strncmp(a,b,n) == 0)
 
 #ifdef __cplusplus
Index: cpukit/libmisc/monitor/symbols.h
===================================================================
--- cpukit/libmisc/monitor/symbols.h	(revision 637df35f96d8023056369fcf2c9943419f1a1b74)
+++ cpukit/libmisc/monitor/symbols.h	(revision b06e68ef1f6df69cc86d72356c3a002054a35fad)
@@ -1,4 +1,7 @@
 /*
- *  File:       symbols.h
+ *	@(#)symbols.h	1.3 - 95/06/09
+ *	
+ *
+ *  RTEMS monitor symbol table functions
  *
  *  Description:
@@ -9,4 +12,5 @@
  *  TODO:
  *
+ *  $Id$
  */
 
@@ -62,13 +66,4 @@
 } rtems_symbol_table_t;
 
-void                  rtems_symbol_table_destroy(rtems_symbol_table_t *table);
-rtems_symbol_table_t *rtems_symbol_table_create();
-rtems_symbol_t       *rtems_symbol_create(rtems_symbol_table_t *,
-                                          char *, rtems_unsigned32);
-rtems_symbol_t       *rtems_symbol_value_lookup(rtems_symbol_table_t *,
-                                                rtems_unsigned32);
-rtems_symbol_t       *rtems_symbol_name_lookup(rtems_symbol_table_t *,
-                                                char *);
-
 #define rtems_symbol_name(sp)   ((sp)->name)
 #define rtems_symbol_value(sp)  ((sp)->value)
